		.title	Si - utilities


* Include File -------------------------------- *

		.include	macro.mac
		.include	doscall.mac


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even


* wAhXǂ݂ŃoXG[邩ׂ
* in	a0.l	AhX
* out	d0.bwl	ǂݍ񂾃f[^
*	ccr	Z=1:I Z=0:oXG[

check_bus_error_byte::
		move	#1,-(sp)
		move.l	sp,-(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		moveq	#0,d0
		move.b	(8,sp),d0
		tst.l	(sp)+
		addq.l	#10-4,sp
		rts

check_bus_error_word::
		move	#2,-(sp)
		move.l	sp,-(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		moveq	#0,d0
		move	(8,sp),d0
		tst.l	(sp)+
		addq.l	#10-4,sp
		rts

check_bus_error_long::
		move	#4,-(sp)
		subq.l	#4,sp
		move.l	sp,(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		move.l	(4,sp),d0
		tst.l	(sp)+
		addq.l	#10-4,sp
		rts

* wAhXǂݏăoXG[邩ׂ
* in	a0.l	AhX
* out	d0.l	0:OK 1:Write Error 2:Read Error -1:Arg Error
*	ccr	Z=1:I Z=0:oXG[

	.if	0
check_bus_error_byte_rw::
		move	#1,-(sp)
		move.l	a0,-(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		addq.l	#10-4,sp
		move.l	d0,(sp)+
		rts
	.endif


* l 16 iɕϊ -------------- *
* ŒA0 l߁AړL($A0x ̗)ȂANUL I[
*  d0.l ̏ʌn(l)
* in	d0.l	l
*	a0.l	obt@
* out	a0.l	+= strlen(a0)

* oCgl -> 
* in	d0.hwhb	l
* out	a0.l	+= 2

hexstr_byte::
		PUSH	d0-d2
		moveq	#2-1,d1
		bra	hexstr_loop

* [hl -> l
* in	d0.hw	l
* out	a0.l	+= 4

hexstr_word::
		PUSH	d0-d2
		moveq	#4-1,d1
		bra	hexstr_loop

* O[hl -> 
* in	d0.l	l
* out	a0.l	+= 8

hexstr_long::
		PUSH	d0-d2
		moveq	#8-1,d1
		bra	hexstr_loop

hexstr_loop:
		rol.l	#4,d0
		moveq	#$f,d2
		and	d0,d2
		move.b	(hex_table,pc,d2.w),(a0)+
		dbra	d1,hexstr_loop
		clr.b	(a0)
		POP	d0-d2
		rts

hex_table:
*		.dc.b	'0123456789ABCDEF'
		.dc.b	'0123456789abcdef'

* O[hl -> 1`8 
* in	d0.l	l
* out	a0.l	+= 
* l:
*	ʌ 0 ͏ȗ.

hexstr_z::
		PUSH	d0-d2
		moveq	#8-1,d1
hexstr_z_loop:
		cmpi.l	#$1000_0000,d0
		bcc	hexstr_loop
		lsl.l	#4,d0
		dbra	d1,hexstr_z_loop
		moveq	#1-1,d1			;0 ̏ꍇ
		bra	hexstr_loop


* O[hl(Ȃ) -> 10 i
* in	d0.l	l(Ȃ)
*	a0.l	obt@
* out	a0.l	+= 

decstr::
		PUSH	d0-d2/a1
		lea	(dec_table,pc),a1
decstr_loop1:
		move.l	(a1)+,d1
		bmi	decstr_1
		cmp.l	d1,d0
		bcs	decstr_loop1
decstr_loop2:
		moveq	#'0'-1,d2
@@:		addq.l	#1,d2
		sub.l	d1,d0
		bcc	@b
		add.l	d1,d0
		move.b	d2,(a0)+
		move.l	(a1)+,d1
		bpl	decstr_loop2
decstr_1:
		addi.b	#'0',d0
		move.b	d0,(a0)+
decstr_end:
		clr.b	(a0)
		POP	d0-d2/a1
		rts

dec_table:
		.dc.l	1000000000
		.dc.l	100000000
		.dc.l	10000000
		.dc.l	1000000
		.dc.l	100000
		.dc.l	10000
		.dc.l	1000
		.dc.l	100
		.dc.l	10
		.dc	-1


* foCXhCo ------------------ *
* in	d0.hw	foCX}XN
*	d0.w	foCX
*	a0.l	foCX(8 oCg̕)
* out	d0.l	foCXwb_̃AhX(0 Ȃ猩Ȃ)
*	a0.l	V
* @\:
*	a0.l Ŏw肵foCXvfoCXwb_̃foCX
*	 d0.hw ̘_ςƂA̒l d0.w Ɣrv΃foC
*	Xwb_̃AhX d0.l  a0.l ɕԂ. d0.l  0 w肷
*	foCX͊Sɖ.
*	foCXꍇAŏ̃foCXԂ.
* :
*	ŝ Human68k  CLOCK foCXȍ~łA
*	Oɂ NULACONAAUXAPRNALPT foCX邱Ƃ
*	oȂ.

device_search::
		PUSH	d1/a1-a3
		move.l	d0,d1
**		clr.l	-(sp)
**		DOS	_SUPER
**		move.l	d0,(sp)

		movea.l	($1cb6),a1		;CLOCK foCX̃AhX
devsch_loop:
		tst.l	d1
		beq	devsch_cmp_name		;foCX͔rsv

		move.l	d1,d0
		and.l	(4,a1),d0		;}XN
		swap	d0
		cmp	d1,d0
		bne	devsch_next
devsch_cmp_name:
		lea	(a0),a2
		lea	(14,a1),a3		;foCX
		moveq	#8-1,d0
devsch_cmp_loop:
		cmpm.b	(a2)+,(a3)+
		dbne	d0,devsch_cmp_loop
		beq	devsch_end		;
devsch_next:
		movea.l	(a1),a1			;̃foCXwb_
		cmpa	#-1,a1
		bne	devsch_loop
		suba.l	a1,a1			;Ȃ
devsch_end:
**		tst	(sp)
**		bmi	devsch_skip
**		DOS	_SUPER
**devsch_skip:	addq.l	#4,sp
		move.l	a1,d0
		POP	d1/a1-a3
		rts


* [ FLOAT t@NV ------------------- *

* FPACK __IDIV
* in	d0.l	폜
*	d1.l	
* out	d0.l	Z()
*	d1.l	V	(])
*	ccr	C=1:G[([Z)
* @\:
*	O[hȂm̏Zs.

fe_idiv::
		tst.l	d1
		beq	fe_idiv_by_zero		;[ZG[

		PUSH	d2-d3
		moveq	#0,d2
		moveq	#32-1,d3
fe_idiv_loop:
		add.l	d0,d0
		addx.l	d2,d2			;d0 ̏ʂ 1 rbgo
		cmp.l	d1,d2
		bcs	fe_idiv_next
		sub.l	d1,d2
		addq	#1,d0
fe_idiv_next:
		dbra	d3,fe_idiv_loop
		move.l	d2,d1			;Carry Clear
		POP	d2-d3
		rts
fe_idiv_by_zero:
		move	#%00001,ccr		;Carry Set
		rts


* FPACK __IUSING
* in	d0.l	O[ht
*	d1.l	
*	a0.l	obt@AhX
* out	a0.l	񖖔̃AhX(NUL w)
* @\:
*	O[htCӂ̌ 10 iɕϊ.

fe_iusing::
		PUSH	d0/a1-a2
		lea	(a0),a1
		tst.l	d0
		bpl	@f
		move.b	#'-',(a0)+		;Si ł͕svꉞɑΉ
		neg.l	d0
@@:
		bsr	decstr			;Ƃ肠
		STRLEN	a1,d0
		sub.l	d0,d1
		bls	fe_iusing_end		;E񂹕sv

		lea	(a0),a1			;]
		adda.l	d1,a0
		lea	(a0),a2			;]
		clr.b	(a0)
fe_iusing_loop1:
		move.b	-(a1),-(a2)		;{̂E񂹂
		subq.l	#1,d0
		bne	fe_iusing_loop1
		moveq	#' ',d0
fe_iusing_loop2:
		move.b	d0,-(a2)		;擪ɋ󔒂
		subq.l	#1,d1
		bne	fe_iusing_loop2
fe_iusing_end:
		POP	d0/a1-a2
		rts


* HUPAIR Decoder ------------------------------ *

GetArgChar_p:	.equ	GetArgCharInit
GetArgChar_c:	.equ	GetArgCharInit+4

GetArgChar::
		PUSH	d1/a0-a1
		moveq	#0,d0
		lea	(GetArgChar_p,pc),a0
		movea.l	(a0)+,a1
		move.b	(a0),d0
		bmi	GetArgChar_noarg
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_endarg
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.b	d1,(a0)
		move.l	a1,-(a0)
GetArgChar_abort:
		POP	d1/a0-a1
		rts
GetArgChar_endarg:
		st	(a0)
		bra	GetArgChar_abort
GetArgChar_noarg:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_abort

GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next

GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		moveq	#0,d0
		tst.b	-(a1)
		beq	GetArgChar_endarg
		bra	GetArgChar_end

GetArgCharInit::
		PUSH	a0-a1
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		tst.b	-(a1)
		lea	(GetArgChar_c,pc),a0
		seq	(a0)
		move.l	a1,-(a0)
		POP	a0-a1
		rts


		.end

* End of File --------------------------------- *
